function B=GenerateBaseStation(P,numbase,scale,celular,R)

global numTxPU numTxSU

%P is a vector with the static positions
%numbase is the number of base stations
%if P is equal to 0, it means that all base station positions are random

tam=size(P);

if celular==0
    
    if tam(2)==0
        B=GeneratePosition(scale,numbase);
    elseif tam(2)==numbase
        B=P; %all base station positions are fixed
    else
        
        bases=numbase-tam(2); %number of stations that have to be random
               
        Raux=GeneratePosition(scale,bases);
        aux=P(:,tam(2));
        aux=aux*ones(1,bases);
        
        R=Raux+aux;
        
        B=[P(:,1:(tam(2)-1)),R,P(:,tam(2))];
    end
    
elseif celular==1
    
    BRxPU=randn(2,1);
    BTxPU=CreatCelular(BRxPU,R,numTxPU);
    
    BRxSU=[BRxPU(1,1)+(rand/100);BRxPU(2,1)+(rand/100)];    
    BTxSU=CreatCelular(BRxSU,R,numTxSU);
    B=[BTxPU BRxPU BTxSU BRxSU];
else
    error('Incorrect value of celular')
end

grid on     
        