function R=Rice(tam,K,mode)
% RICE Generating an array with Rice distributed Elements
% rice(numbase,K,sigma)

% Variables:
% numbase : Number of base stations
% K :  Rice Factor
if K>=4
    x0=1/sqrt(2)*randn(tam(1),tam(2));
    y0=1/sqrt(2)*randn(tam(1),tam(2));
elseif K<4 && K>=0
    x0=randn(tam(1),tam(2));
    y0=randn(tam(1),tam(2));
else
    error('Invalid K factor');
end

kx0=sqrt(K)*cos(rand(tam(1),tam(2))*2*pi); 
ky0=sqrt(K)*sin(rand(tam(1),tam(2))*2*pi);

Rx0=x0+kx0;
Ry0=y0+ky0;

aux=sqrt(Rx0.^2+Ry0.^2);

if mode==0    
    R=10*log10(aux); 
else
    R=aux; 
end    