function [Posout,Pout,rout,Xout,Aqout,qout,qQout,SNRout,TotalPack,DropPack]=simple_model()
 

%-------------------------------------------------------------------
%Inicialization
[names,data]=textread('parameters.txt','%s%f','commentstyle','matlab');
[x,y]=textread('fixed_positions.txt','%f%f','commentstyle','matlab');
[xs,ys]=textread('fixed_Sensors.txt','%f%f','commentstyle','matlab');

global numTxPU numRxPU numTxSU numRxSU numSensors N0 PtxPU TotalPack DropPack 
global Pmax controlqueue  bits
global celularBase Rbase celularSens  Rsens numfrec numbits

close all

numTxPU=data(1);
numRxPU=1;
numTxSU=data(3);
numRxSU=1;
numSensors=data(5);
scale=data(6);
sigmaS=data(7);
hb=data(8);
hm=data(9);
celularBase=data(10);
Rbase=data(11);
celularSens=data(12);
Rsens=data(13);
prob=data(14);
bits=data(15);
controlqueue=data(16);
PtxPU=data(17); %db
PtxSU=data(18); %db
Pmax=data(19);
Xav=data(20);
Xmin=data(21);
work=data(22);
numfrec=data(23);
numbits=data(24);
load_data=data(25);

Pb=[x,y]';
Ps=[xs,ys]';
cont=1;
%-------------------------------------------------------------------


%----------------------------MAIN PROGRAM---------------------------



%----------------- CREATE ENVIROMENT ------------------------------- 
       
        
       [Cavg,Intavg,Esavg,Dsavg]=CreateEnviroment(Pb,Ps,scale,hb,hm,sigmaS);
       
       if load_data==1
           
        load('load_data_file')
        Cavg=CavgSave;
        Intavg=IntavgSave;
        Esavg=EsavgSave;
        Dsavg=DsavgSave;        

           
       end
           
        
       
%---Output Inicialization---       
         
        Posout=zeros(numfrec,work);                
        Pout=zeros(numfrec,numTxSU,work);
        rout=zeros(numfrec,numTxSU,work);

        Xout=zeros(numfrec,numSensors,work);
        Aqout=zeros(numTxSU,work);
        qout=zeros(numTxSU,work);
        
        qQout=zeros(numTxSU,work);
        
        SNRout=zeros(numfrec,numTxSU,work);
        
        
        cout=zeros(numfrec,numTxSU,work);
        intout=zeros(numfrec,numTxPU,work);
        esout=zeros(numSensors,numTxPU,numfrec,work);
        dsout=zeros(numSensors,numTxSU,numfrec,work);


        TotalPack=zeros(1,numTxSU);
        DropPack=zeros(1,numTxSU);
        
%-----------------------------
   
        X0=Xmin*ones(numfrec,numSensors);
        q=zeros(1,numTxSU);
              
        SP=0.1*ones(1,numSensors)';
        BP=0.1*ones(1,numSensors)';
        
while work>cont
    
    
        %-------------- NOISE -------------------------------  
        kb=1.3806e-23; %Boltzmann constant
        T=300;
        N0=randn(1)*kb*T;


        %-------------- CONTROL PERIOD -------------------------------  

        %-------- Tx Users ------------------------
        [Aqout0,qQ,q1,SNR]=Transmittersfunction(prob,bits,Cavg,Intavg,q) ;    
        %------------------------------------------ 

        %--------FUNCION CENTER -------------------
        [p,X,posTx,Po,q,r]=FunsionCenter(X0,Xav,Xmin,BP,SP,qQ,q1,SNR,Dsavg);
        %------------------------------------------

        %------------------------------------------------------------


        %------ SILENT PERIOD and BUSY PERIOD  ---------------------

        
        %--------- UPDATE CHANNEL ----
        [C,Int,Es,Ds]=CalulateFastFading(Cavg,Intavg,Esavg,Dsavg);
        %------------------------------

        PtxSU=10*log10(p);
        [SP,BP]=Sensorfunct(PtxPU,PtxSU,Es,Ds,posTx);    
        %-----------------------------------------------------------   

    
        
        %-----  OUTPUT ------
             Posout(:,cont)=posTx;
             Pout(:,:,cont)=PtxSU;
             SNRout(:,:,cont)=SNR;
             
             for i=1:numfrec
                 raux=zeros(1,numTxSU);
                 raux(posTx(i))=r(i,posTx(i));   
                 rout(i,:,cont)=raux;             
             end
             
             
             Xout(:,:,cont)=X;
             Aqout(:,cont)=Aqout0;
             qout(:,cont)=q;
             
            V=controlqueue*bits;
             
            
            for i=1:numTxSU           
                 
                 Vunq=data_queue_unquant(qQ(i*numbits-(numbits-1):i*numbits),numbits,V);   
                 qQout(i,cont)=Vunq;
             
             end
             
             cout(:,:,cont)=C;
             intout(:,:,cont)=Int;
             esout(:,:,:,cont)=Es; 
             dsout(:,:,:,cont)=Ds;
        %-------------    
          
           
     
    %----------UPDATE VECTORS------------------     
            cont=cont+1;
            X0=X;            
     %----------------------------         
end           

%----------SAVE DATA------------------

if load_data==0
    
            CavgSave=Cavg;
           IntavgSave=Intavg;
           EsavgSave=Esavg;
           DsavgSave=Dsavg;
           
           save('load_data_file','CavgSave','IntavgSave','EsavgSave','DsavgSave')
end



%----------REPRESENTATION------------------ 
Xavgout=Xav*ones(work,1);




for i=1:numfrec

figure
subplot(3,1,1)

aux1=Pout(i,:,:);
aux2=reshape(aux1,numTxSU,work);
plot(aux2');
title('PoutTx') 
ylabel('dBs')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

subplot(3,1,2)
aux1=rout(i,:,:);
aux2=reshape(aux1,numTxSU,work);

plot(aux2')
title('Data rate of each user')
ylabel('Bits/iteration')
xlabel('Iterations')    
legend('Tx1','Tx2','Tx3','Tx4');

subplot(3,1,3)
qoutlimit=(controlqueue*bits)*ones(work,1);

subplot(3,1,3)
plot(qout')
hold on
plot(qoutlimit,'r');
hold off
title('Data queue')
ylabel('Number of bits')
xlabel('Iterations')   
legend('Tx1','Tx2','Tx3','Tx4');  
    
    
figure
subplot(3,1,1)

aux1=Pout(i,:,:);
aux2=reshape(aux1,numTxSU,work);
plot(aux2');
title('PoutTx') 
ylabel('dBs')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

subplot(3,1,2)
plot(Aqout');
title('Arrival data')
ylabel('Number of bits')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

subplot(3,1,3)
aux1=rout(i,:,:);
aux2=reshape(aux1,numTxSU,work);

plot(aux2')
title('Data rate of each user')
ylabel('Bits/iteration')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

figure
subplot(3,1,1)
aux1=rout(i,:,:);
aux2=reshape(aux1,numTxSU,work);

plot(aux2');
title('Transmitted data rate')
ylabel('Bits/iteration')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

subplot(3,1,2)
aux1=Xout(i,:,:);
aux2=reshape(aux1,numSensors,work);

plot(10*log10(aux2'),'b');
hold on
plot(10*log10(Xavgout'),'r');
hold off
title('Interference queue')
ylabel('Interference level')
xlabel('Iterations')

qoutlimit=(controlqueue*bits)*ones(work,1);

subplot(3,1,3)
plot(qout')
hold on
plot(qoutlimit,'r');
hold off
title('Data queue')
ylabel('Number of bits')
xlabel('Iterations')
legend('Tx1','Tx2','Tx3','Tx4');

%----------Channel state------------------ 

figure
subplot(4,1,1)

aux1=cout(i,:,:);
aux2=reshape(aux1,numTxSU,work);

plot(-1*aux2');
title('TxSU-RxSU (c) Channel state')
ylabel('dBs')
xlabel('Iterations')

subplot(4,1,2)

aux1=intout(i,:,:);
aux2=reshape(aux1,numTxPU,work);

plot(-1*aux2');
title('TxPU-RxSU (int) Channel state')
ylabel('dBs')
xlabel('Iterations')

subplot(4,1,3)

aux1=esout(:,1,i,:);
aux2=reshape(aux1,numSensors,work);

plot(-1*aux2')
title('TxPU-RxPU (es) Channel state')
ylabel('dBs')
xlabel('Iterations')

subplot(4,1,4)

aux1=dsout(:,1,i,:);
aux2=reshape(aux1,numSensors,work);

plot(-1*aux2')
title('TxSU-RxPU (ds) Channel state')
ylabel('dBs')
xlabel('Iterations')

end
%----------Packect state------------------ 


figure

subplot(3,1,1)
bar(TotalPack);
title('Total Packets')
ylabel('Packets Number')
xlabel('TxSU Users')


SendPack=TotalPack-DropPack;

subplot(3,1,2)
bar(SendPack);
title('Send Packets')
ylabel('Packets Number')
xlabel('TxSU Users')

subplot(3,1,3)
bar(DropPack);
title('Drop Packets')
ylabel('Packets Number')
xlabel('TxSU Users')

figure
plot(1:numTxSU,TotalPack)
hold on
plot(1:numTxSU,SendPack,'g')
plot(1:numTxSU,DropPack,'r')
hold off

%------ data queue --------------


figure

for i=1:numTxSU
    
    subplot(numTxSU,1,i)
    plot(qout(i,:));
    hold on
    plot(qQout(i,:),'r');
    hold off
        
    title('Data queue')
    %ylabel('Number of bits')
    xlabel('Iterations')
end






