function test_Rayleigh(numbase,num)

% test_Rayleigh function checks that generated variables follow the
% Rayleigh distribution
% num means number of repetitions
% numbase means number of base stations

FF=raylrnd(1,numbase);
aux=FF;
   
   %Other realizations
   for i=1:num-1
       FF=raylrnd(1,numbase);
       aux=cat(3,aux,FF);
   end

% Make the histogram

x=aux(1,2,:);
p=reshape(x,1,num);
bin=sqrt(num);
N=hist(p,bin);
range=max(p)-min(p);
stepp=range/bin;
Nnormalize=N/num/stepp;
subplot(3,1,2)
plot(min(p)+(stepp/2):stepp:max(p)-(stepp/2),Nnormalize)
title('Test Rayleigh');
ylabel('Probability density function');
xlabel('Values');
hold on

x=0:0.01:4;
RAF=raylpdf(x,1);
plot(x,RAF,'r');
legend('Generated values','Theoretical values');

hold off